#This file lists everything in gamelist.xml
import os
import shutil
import urllib.request as urllib
import requests
import xml.etree.ElementTree as ET
import configparser
import io

masterconfig = configparser.ConfigParser()
masterconfig.sections()
masterconfig.read('config.ini')
config = masterconfig['master']



#define output locations
mgalaxyDBfile = config["mgalaxyDBfile"]
#Steamdb source
gamelistxml = config["gamelistxml"]
steamxmlloc = config["steamxmlloc"]

#define location of xml files
urllib.urlretrieve(gamelistxml,steamxmlloc)
fp = open(steamxmlloc,"r")
doc = ET.parse(fp)
for game in doc.findall('games/game'): 
    appID = game.find('appID')
    name = game.find('name')
    if  name.text.find(":") > -1:
        gameFileName = name.text[0:name.text.find(":")]
        gameAppId = appID.text
    else:
        if name.text.find("(") > -1:
            gameFileName = name.text[0:name.text.find("(")]
            gameAppId = appID.text
        else:
            gameFileName = name.text
            gameAppId = appID.text
    print (gameFileName + " : " + gameAppId)
    #pull from json
    steam_url = r"https://store.steampowered.com/api/appdetails?appids=" + gameAppId
    resp = requests.get(steam_url)
    steam_json = resp.json()
    print (resp)
    
    #pull from steam
    try:
        description = str(steam_json[gameAppId]['data']['short_description'])
    except:
        print ("no description")

    #multiples
    try:
        genres = str(steam_json[gameAppId]['data']['genres'][0]['description'])
    except:
        print ("no genres")
    try:
        release = str(steam_json[gameAppId]['data']['release_date']['date'])
    except:
        print ("no no release date")
    try:
        players = str(steam_json[gameAppId]['data']['categories'][0]['description'])
    except:
        print ("no no release date")


    #update database file
    releasex = r".//game[@name='"+gameFileName+"']/release"
    genrex = r".//game[@name='"+gameFileName+"']/genre"
    playerx = r".//game[@name='"+gameFileName+"']/players"
    descriptionx = r".//game[@name='"+gameFileName+"']/overview"
    try:
        tree = ET.parse(mgalaxyDBfile)
        tree.find(releasex).text = release
        tree.find(genrex).text = genres
        #tree.find(playerx).text = players
        tree.find(descriptionx).text = description
        tree.write(mgalaxyDBfile)
    except:
        print ("unable to update db")
